#!/usr/bin/gawk -f
#
## Generic Makefile for C++ Projects - Dependency Generation Helper
##
## Copyright 2020,2021 Christian Schneider <software(at)chschneider(dot)eu>
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License version 3 as
## published by the Free Software Foundation, *not* any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

@load "filefuncs"

BEGIN {
  LIBS["\\<fschksum.o\\>"]            = "-lcppdb -lstdc++fs -lcrypto"
}

(ARGIND == 1) {
  if ($0 ~ /int *main *\(/) {
    HAS_MAIN = 1
    nextfile
  }
  next
}

(HAS_MAIN != 1) {
  exit 0
}

{
  for (I = 1; I <= NF; I++) {
    if (I == 1 && $I ~ /\.o:$/)
      X = gensub(/\.o:$/, ":", "1", $I)

    C = gensub(/\.hpp$/, ".cpp", "1", $I)
    O = gensub(/\.cpp$/, ".o",   "1", C)
    if (C ~ /\.cpp$/ && stat(C, STATDATA) == 0)
      X = X " " O

    for (L in LIBS) {
      if (O ~ L)
        DEPS = DEPS " " LIBS[L]
    }

    if (I == NF && $I != "\\")
      nextfile
  }
}

END {
  if (X != "") {
    print X " " DEPS
    print ""
    print gensub(/:/, "_static:", "1", X)
    print gensub(/:.*/, "_static: LDLIBS += " DEPS, "1", X)
    print ""
  }
}
